//+------------------------------------------------------------------+
//|                                                 FFS_Trend_v2.mq4 |
//|                           Fixed by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "icm63 (user name at Forex-TSD)"
#property link      "Forex-TSD"

/* 

This is the index selection format
1. EUR/USD, USD/CHF
2. EUR/USD, USD/CHF, GBP/USD
3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
4. EUR/USD, USD/CHF, USD/JPY
5. EUR/USD, GBP/USD, USD/JPY
6. USD/CHF, GBP/USD
7. USD/CHF, GBP/USD, USD/JPY
8. GBP/USD, USD/JPY


*/

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Yellow

//User Inputs Parameters
extern int IndexType = 3;
extern int NoBars = 100;
//---- variables
double normUSDpos[];
double normUSDneg[];
double USDpos[];
double USDneg[];


int init()
  {
   IndicatorShortName("FFS_Trend USD_Positive: RED USD_Negative: YELLOW");
   IndicatorBuffers(4);
   SetIndexDrawBegin(0,500);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,normUSDpos);
   SetIndexLabel(0, "USDpos");
   SetIndexDrawBegin(1,500); 
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,normUSDneg);
   SetIndexLabel(1, "USDneg");  
   SetIndexBuffer(2,USDpos);
   SetIndexBuffer(3,USDneg);
   return(0);
  }
  //Comments to Main Cart on FFS Index types and long swap.
  void MyComments(int Index)
  {
    string Selection;
    string Nature;
    double NS1, NS2, NS3, NS4, NS5, NS6, NS7, NS8;
    
    NS1 = MarketInfo("EURUSD",MODE_SWAPLONG)+ MarketInfo("USDCHF",MODE_SWAPLONG);
    NS2 = MarketInfo("EURUSD",MODE_SWAPLONG)+ MarketInfo("USDCHF",MODE_SWAPLONG) 
    + MarketInfo("GBPUSD",MODE_SWAPLONG);
    NS3 = MarketInfo("EURUSD",MODE_SWAPLONG)+ MarketInfo("USDCHF",MODE_SWAPLONG) 
    + MarketInfo("GBPUSD",MODE_SWAPLONG)+ MarketInfo("USDJPY",MODE_SWAPLONG);
    NS4 = MarketInfo("EURUSD",MODE_SWAPLONG)+ MarketInfo("USDCHF",MODE_SWAPLONG) 
    + MarketInfo("USDJPY",MODE_SWAPLONG);
    NS5 = MarketInfo("EURUSD",MODE_SWAPLONG)+ MarketInfo("GBPUSD",MODE_SWAPLONG) 
    + MarketInfo("USDJPY",MODE_SWAPLONG);
    NS6 = MarketInfo("USDCHF",MODE_SWAPLONG)+ MarketInfo("GBPUSD",MODE_SWAPLONG);
    NS7 = MarketInfo("USDCHF",MODE_SWAPLONG)+ MarketInfo("GBPUSD",MODE_SWAPLONG) 
    + MarketInfo("USDJPY",MODE_SWAPLONG);
    NS8 = MarketInfo("GBPUSD",MODE_SWAPLONG)+ MarketInfo("USDJPY",MODE_SWAPLONG);
    
     switch(Index)
      {
      case 1:
            Selection = "1. EUR/USD, USD/CHF";
            Nature = "Closest negative correlation, best hedge, lowest rewards.";
            break;
      case 2:
            Selection = "2. EUR/USD, USD/CHF, GBP/USD";
            Nature = "GBP adds some volatility, low interest";
            break;
      case 3:
            Selection = "3. EUR/USD, USD/CHF, GBP/USD, USD/JPY";
            Nature = "JPY adds more volatility, pays most interest.";
            break;
      case 4:
            Selection = "4. EUR/USD, USD/CHF, USD/JPY";
            Nature = "Removes the (low) interest cost of the GBP.";
            break;
      case 5:
            Selection = "5. EUR/USD, GBP/USD, USD/JPY";
            Nature = "More volatility without the CHF, low interest.";
            break;
      case 6:
            Selection = "6. USD/CHF, GBP/USD";
            Nature = "Removes the (high) interest cost of the EUR.";
            break;
      case 7:
            Selection = "7. USD/CHF, GBP/USD, USD/JPY";
            Nature = "More volatile without the EUR.";
            break;
      case 8:
            Selection = "8. GBP/USD, USD/JPY";
            Nature = "Most volatile. Valium recommended.";
            break;
      default:
            Selection = "3. EUR/USD, USD/CHF, GBP/USD, USD/JPY";
            Nature = "JPY adds more volatility, pays most interest.";
            break;
     }
   
       Comment(
       " \n"+
       "FFS Index selected : " + Selection + "\n" + 
       "FFS Description: " + Nature + "\n" + 
       "FFS Swap by Index (Long swap only): " + "\n"+
         "1.. " + DoubleToStr(NS1,2) + " "+
         " 2.. " + DoubleToStr(NS2,2) + " "+
         " 3.. " + DoubleToStr(NS3,2) + " "+
         " 4.. " + DoubleToStr(NS4,2) + "\n"+
         "5.. " + DoubleToStr(NS5,2) + " "+
         " 6.. " + DoubleToStr(NS6,2) + " "+
         " 7.. " + DoubleToStr(NS7,2) + " "+
         " 8.. " + DoubleToStr(NS8,2));
  }
  
int deinit()
  {   
   return(0);
  }
int start()
  {      
 
     int limit;
     int counted_bars=IndicatorCounted();
      if ( counted_bars > 0 )  limit=Bars-counted_bars;
      if ( counted_bars < 0 )  return(0);
      if ( counted_bars ==0 )  limit=Bars-1; 
       
     for(int i=limit; i>=0; i--)
       {
            switch(IndexType)
               {
               case 1:
                     //1. EUR/USD, USD/CHF"
                     USDpos[i]=  iClose("EURUSD",0,i) * 10000;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000;
                     break;
               case 2:
                     //2. EUR/USD, USD/CHF, GBP/USD
                     USDpos[i]=  iClose("EURUSD",0,i) * 10000 + iClose("GBPUSD",0,i)  * 10000 ;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000;
                     break;
               case 3:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     USDpos[i]=  iClose("EURUSD",0,i) * 10000 + iClose("GBPUSD",0,i)  * 10000 ;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000 + iClose("USDJPY",0,i)  * 100 ;
                     break;
               case 4:
                     //4. EUR/USD, USD/CHF, USD/JPY
                     USDpos[i]=  iClose("EURUSD",0,i) * 10000;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000 + iClose("USDJPY",0,i)  * 100 ;
                     break;
               case 5:
                     //5. EUR/USD, GBP/USD, USD/JPY
                     USDpos[i]=   iClose("EURUSD",0,i) * 10000 + iClose("GBPUSD",0,i)  * 10000 ;
                     USDneg[i]=   iClose("USDJPY",0,i) * 100 ;
                     break;
               case 6:
                     //6. USD/CHF, GBP/USD
                     USDpos[i]=  iClose("GBPUSD",0,i) * 10000 ;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000 ;
                     break;
               case 7:
                     //7. USD/CHF, GBP/USD, USD/JPY
                     USDpos[i]=  iClose("GBPUSD",0,i) * 10000 ;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000 + iClose("USDJPY",0,i)  * 100 ;
                     break;  
               case 8:
                     //8. GBP/USD, USD/JPY 
                     USDpos[i]=  iClose("GBPUSD",0,i) * 10000 ;
                     USDneg[i]=  iClose("USDJPY",0,i)  * 100 ;
                     break;
               default:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     USDpos[i]=  iClose("EURUSD",0,i) * 10000 + iClose("GBPUSD",0,i)  * 10000 ;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000 + iClose("USDJPY",0,i)  * 100 ;
                     break;
              }
       
               double MaxPos=-10000000, MinPos=10000000;
               double MaxNeg=-10000000, MinNeg=10000000;
       
                 for ( int k=0; k<NoBars-1;k++)
                 {
                 if( USDpos[i+k] > MaxPos) MaxPos = USDpos[i+k];
                 if( USDpos[i+k] < MinPos) MinPos = USDpos[i+k];
                 if( USDneg[i+k] > MaxNeg) MaxNeg = USDneg[i+k];
                 if( USDneg[i+k] < MinNeg) MinNeg = USDneg[i+k];
                 }
               //Print("Minpos=",MinPos," maxpos=",MaxPos);
               //Print("Maxneg=",MaxNeg," minneg=",MinNeg);
       }
       //Normalise Data btw 0 and 100
       for(int m=limit; m>=0; m--)
       {
         if (MaxPos - MinPos != 0) normUSDpos[m] = 100*(USDpos[m]-MinPos)/(MaxPos-MinPos);  
         if (MaxNeg - MinNeg != 0) normUSDneg[m] = 100*(USDneg[m]-MinNeg)/(MaxNeg-MinNeg); 
       }
       
       MyComments(IndexType);
    return(0);
  }
//+------------------------------------------------------------------+